﻿
#include <Windows.h>
#include <math.h>
#include "pch.h"
#include <iostream>

#define PI      3.141519
	
#define		START_X_POS		10		//	공의 초기 시작 x의 위치 좌표
#define		START_Y_POS		500		//	공의 초기 시작 y의 위치 좌표

#define		INITIAL_VELOCITY	120	//	공의 초기 속도

HDC   g_hMemDC = NULL;
HDC   g_hBackDC = NULL;
HBITMAP   g_hBackBMP = NULL;
SIZE g_ClientSize;

float x = START_X_POS;         //	공의 x 좌표
float y = START_Y_POS;         //	공의 y 좌표
float diameter = 25.f;         //	공의 지름

//	포물선 운동
float v_0 = INITIAL_VELOCITY;		//	던지는 힘(공의 속도)
double angle = 85.f;				//	던지는 각도
float gravity = 30.f;				//	중력
double radian = angle * PI / 180;	//	각도를 호도법으로 변환
float Time = 0.f;
double z = 0.f;						//	공이 튀어오를 값

void Draw(HDC _hDC)
{
	Ellipse(_hDC, 
		(int)x, (int)(y - z), 
		(int)(x + diameter), (int)(y - z + diameter)
	);
}

void Action(void)
{
	//	포물선의 식
	z = tan(radian) * Time - (gravity / (2.0 * v_0 * v_0 * cos(radian) * cos(radian))) * Time * Time;

	Time += 0.1f;
	//	x += 0.19f;
}

void Check_Crash(HWND hWnd)
{
	//	공이 착지한 경우라면
	if (y - z > START_Y_POS)
	{
		/*	던지는 힘(속도)를 감쇠해서 다음 번에 튀어오를 때는 이전의 높이보다 낮게 튀어오르게 설정	*/
		Time = 0.f;			//	시각 초기화
		z = 0;
		y = START_Y_POS;	//	공의 초기 위치를 다시 설정
		v_0 *= 0.75f;		//	던지는 힘을 감쇠

		//	공의 속도가 0이면 더 이상 튀어오를 수 없으므로 속도를 0으로 설정
		if (v_0 <= 0.0001)
		{
			y = START_Y_POS;	//	공의 초기 위치를 다시 설정
			Time = 0.f;			//	시각 초기화
			z = 0;
			v_0 = 0;			//	속도 초기화
		}
	}
}

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR strCmdLine, int nShowCmd) {
	WNDCLASSEX wcex;
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_HREDRAW | CS_VREDRAW;
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wcex.hInstance = hInstance;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hIconSm = NULL;
	wcex.lpszMenuName = NULL;
	wcex.lpfnWndProc = WndProc;
	wcex.lpszClassName = L"MathF";
	RegisterClassEx(&wcex);
	HWND hWnd = CreateWindow(L"MathF", L"MathF", WS_SYSMENU,
		CW_USEDEFAULT, CW_USEDEFAULT, 800, 600, NULL, NULL, hInstance, NULL);
	if (hWnd == NULL) {
		MessageBox(NULL, L"윈도우 생성 실패", L"에러", MB_ICONERROR | MB_OK);
		return -1;
	}
	ShowWindow(hWnd, SW_SHOW);

	MSG msg;
	memset(&msg, NULL, sizeof(msg));

	while (msg.message != WM_QUIT)
	{

		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		Sleep(5);
		Action();
		Check_Crash(hWnd);
		InvalidateRect(hWnd, NULL, FALSE);
	}
	return 0;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
	{
		RECT rc;
		GetClientRect(hWnd, &rc);
		g_ClientSize.cx = rc.right - rc.left;
		g_ClientSize.cy = rc.bottom - rc.top;
		HDC hdC = GetDC(hWnd);
		g_hMemDC = CreateCompatibleDC(hdC);
		g_hBackDC = CreateCompatibleDC(hdC);
		g_hBackBMP = CreateCompatibleBitmap(hdC, g_ClientSize.cx, g_ClientSize.cy);
		SelectObject(g_hBackDC, g_hBackBMP);
		break;
	}
	case WM_PAINT:
	{
		PAINTSTRUCT ps;
		HDC hDC = BeginPaint(hWnd, &ps);
		BitBlt(hDC, 0, 0, g_ClientSize.cx, g_ClientSize.cy, g_hBackDC, 0, 0, SRCCOPY);
		Draw(g_hBackDC);
		EndPaint(hWnd, &ps);
		break;
	}
	case WM_DESTROY:
	{
		DeleteDC(g_hBackDC);
		DeleteObject(g_hBackBMP);
		DeleteDC(g_hMemDC);
		PostQuitMessage(0);
		break;
	}
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}